unit schTiendaWebClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_osc_Customers = '{85FA0E20-56F7-4122-A90E-4045C39D1856}';
  RID_GetLastID = '{9FBC4C39-89E7-496F-84C0-7E397D388B47}';
  RID_osc_AddressBook = '{368DCB17-688D-4CB7-8A90-427425E4BBBE}';
  RID_TiendaWeb = '{15B99A68-FE61-40FD-8F2C-8175645765F4}';
  RID_osc_Manufacturers = '{9D98A008-2069-4F82-B787-382FCBE05F23}';
  RID_osc_Languages = '{8CB55538-D9C8-424C-8147-1E65E9311480}';
  RID_osc_Products = '{4696ECBC-A105-47B9-8DDF-0C4CB7305361}';
  RID_osc_Orders = '{3E159C75-FC86-49A8-8861-864F31248B1D}';
  RID_osc_Orders_products = '{BCE09911-F3DB-4EC1-87B3-43624244DDFA}';
  RID_osc_Orders_status_history = '{A7A9B08D-236A-49B1-ADC8-57CD0344170A}';

  { Data table names }
  nme_osc_Customers = 'osc_Customers';
  nme_GetLastID = 'GetLastID';
  nme_osc_AddressBook = 'osc_AddressBook';
  nme_TiendaWeb = 'TiendaWeb';
  nme_osc_Manufacturers = 'osc_Manufacturers';
  nme_osc_Languages = 'osc_Languages';
  nme_osc_Products = 'osc_Products';
  nme_osc_Orders = 'osc_Orders';
  nme_osc_Orders_products = 'osc_Orders_products';
  nme_osc_Orders_status_history = 'osc_Orders_status_history';

  { osc_Customers fields }
  fld_osc_Customerscustomers_id = 'customers_id';
  fld_osc_Customerscustomers_firstname = 'customers_firstname';
  fld_osc_Customerscustomers_lastname = 'customers_lastname';
  fld_osc_Customerscustomers_email_address = 'customers_email_address';
  fld_osc_Customerscustomers_default_address_id = 'customers_default_address_id';
  fld_osc_Customerscustomers_telephone = 'customers_telephone';
  fld_osc_Customerscustomers_fax = 'customers_fax';
  fld_osc_Customerscustomers_password = 'customers_password';
  fld_osc_Customersrdx_customers_id_local = 'rdx_customers_id_local';
  fld_osc_Customersdate_account_created = 'date_account_created';
  fld_osc_Customersdate_account_last_modified = 'date_account_last_modified';

  { osc_Customers field indexes }
  idx_osc_Customerscustomers_id = 0;
  idx_osc_Customerscustomers_firstname = 1;
  idx_osc_Customerscustomers_lastname = 2;
  idx_osc_Customerscustomers_email_address = 3;
  idx_osc_Customerscustomers_default_address_id = 4;
  idx_osc_Customerscustomers_telephone = 5;
  idx_osc_Customerscustomers_fax = 6;
  idx_osc_Customerscustomers_password = 7;
  idx_osc_Customersrdx_customers_id_local = 8;
  idx_osc_Customersdate_account_created = 9;
  idx_osc_Customersdate_account_last_modified = 10;

  { GetLastID fields }
  fld_GetLastIDlast_id = 'last_id';

  { GetLastID field indexes }
  idx_GetLastIDlast_id = 0;

  { osc_AddressBook fields }
  fld_osc_AddressBookaddress_book_id = 'address_book_id';
  fld_osc_AddressBookcustomers_id = 'customers_id';
  fld_osc_AddressBookentry_gender = 'entry_gender';
  fld_osc_AddressBookentry_company = 'entry_company';
  fld_osc_AddressBookentry_firstname = 'entry_firstname';
  fld_osc_AddressBookentry_lastname = 'entry_lastname';
  fld_osc_AddressBookentry_street_address = 'entry_street_address';
  fld_osc_AddressBookentry_suburb = 'entry_suburb';
  fld_osc_AddressBookentry_postcode = 'entry_postcode';
  fld_osc_AddressBookentry_city = 'entry_city';
  fld_osc_AddressBookentry_state = 'entry_state';
  fld_osc_AddressBookentry_country_id = 'entry_country_id';
  fld_osc_AddressBookentry_zone_id = 'entry_zone_id';
  fld_osc_AddressBookentry_telephone = 'entry_telephone';
  fld_osc_AddressBookrdx_address_book_id_local = 'rdx_address_book_id_local';

  { osc_AddressBook field indexes }
  idx_osc_AddressBookaddress_book_id = 0;
  idx_osc_AddressBookcustomers_id = 1;
  idx_osc_AddressBookentry_gender = 2;
  idx_osc_AddressBookentry_company = 3;
  idx_osc_AddressBookentry_firstname = 4;
  idx_osc_AddressBookentry_lastname = 5;
  idx_osc_AddressBookentry_street_address = 6;
  idx_osc_AddressBookentry_suburb = 7;
  idx_osc_AddressBookentry_postcode = 8;
  idx_osc_AddressBookentry_city = 9;
  idx_osc_AddressBookentry_state = 10;
  idx_osc_AddressBookentry_country_id = 11;
  idx_osc_AddressBookentry_zone_id = 12;
  idx_osc_AddressBookentry_telephone = 13;
  idx_osc_AddressBookrdx_address_book_id_local = 14;

  { TiendaWeb fields }
  fld_TiendaWebID = 'ID';
  fld_TiendaWebID_EMPRESA = 'ID_EMPRESA';
  fld_TiendaWebTIENDA_ACTIVA = 'TIENDA_ACTIVA';
  fld_TiendaWebBDSERVER = 'BDSERVER';
  fld_TiendaWebBDPORT = 'BDPORT';
  fld_TiendaWebBDNAME = 'BDNAME';
  fld_TiendaWebBDUSER = 'BDUSER';
  fld_TiendaWebBDPASS = 'BDPASS';
  fld_TiendaWebULTIMA_ACTUALIZACION = 'ULTIMA_ACTUALIZACION';

  { TiendaWeb field indexes }
  idx_TiendaWebID = 0;
  idx_TiendaWebID_EMPRESA = 1;
  idx_TiendaWebTIENDA_ACTIVA = 2;
  idx_TiendaWebBDSERVER = 3;
  idx_TiendaWebBDPORT = 4;
  idx_TiendaWebBDNAME = 5;
  idx_TiendaWebBDUSER = 6;
  idx_TiendaWebBDPASS = 7;
  idx_TiendaWebULTIMA_ACTUALIZACION = 8;

  { osc_Manufacturers fields }
  fld_osc_Manufacturersmanufacturers_id = 'manufacturers_id';
  fld_osc_Manufacturersmanufacturers_name = 'manufacturers_name';
  fld_osc_Manufacturersmanufacturers_image = 'manufacturers_image';
  fld_osc_Manufacturersdate_added = 'date_added';
  fld_osc_Manufacturerslast_modified = 'last_modified';
  fld_osc_Manufacturersrdx_manufacturers_id_local = 'rdx_manufacturers_id_local';

  { osc_Manufacturers field indexes }
  idx_osc_Manufacturersmanufacturers_id = 0;
  idx_osc_Manufacturersmanufacturers_name = 1;
  idx_osc_Manufacturersmanufacturers_image = 2;
  idx_osc_Manufacturersdate_added = 3;
  idx_osc_Manufacturerslast_modified = 4;
  idx_osc_Manufacturersrdx_manufacturers_id_local = 5;

  { osc_Languages fields }
  fld_osc_Languageslanguages_id = 'languages_id';
  fld_osc_Languagesname = 'name';
  fld_osc_Languagescode = 'code';
  fld_osc_Languagesimage = 'image';
  fld_osc_Languagesdirectory = 'directory';
  fld_osc_Languagessort_order = 'sort_order';

  { osc_Languages field indexes }
  idx_osc_Languageslanguages_id = 0;
  idx_osc_Languagesname = 1;
  idx_osc_Languagescode = 2;
  idx_osc_Languagesimage = 3;
  idx_osc_Languagesdirectory = 4;
  idx_osc_Languagessort_order = 5;

  { osc_Products fields }
  fld_osc_Productsproducts_id = 'products_id';
  fld_osc_Productsproducts_name = 'products_name';
  fld_osc_Productsproducts_description = 'products_description';
  fld_osc_Productsproducts_model = 'products_model';
  fld_osc_Productsproducts_date_added = 'products_date_added';
  fld_osc_Productsproducts_last_modified = 'products_last_modified';
  fld_osc_Productsproducts_status = 'products_status';
  fld_osc_Productsmanufacturers_id = 'manufacturers_id';
  fld_osc_Productsrdx_products_id_local = 'rdx_products_id_local';

  { osc_Products field indexes }
  idx_osc_Productsproducts_id = 0;
  idx_osc_Productsproducts_name = 1;
  idx_osc_Productsproducts_description = 2;
  idx_osc_Productsproducts_model = 3;
  idx_osc_Productsproducts_date_added = 4;
  idx_osc_Productsproducts_last_modified = 5;
  idx_osc_Productsproducts_status = 6;
  idx_osc_Productsmanufacturers_id = 7;
  idx_osc_Productsrdx_products_id_local = 8;

  { osc_Orders fields }
  fld_osc_Ordersorders_id = 'orders_id';
  fld_osc_Ordersrdx_orders_id_local = 'rdx_orders_id_local';
  fld_osc_Orderscustomers_id = 'customers_id';
  fld_osc_Ordersrdx_customers_id_local = 'rdx_customers_id_local';
  fld_osc_Ordersdelivery_name = 'delivery_name';
  fld_osc_Ordersdelivery_company = 'delivery_company';
  fld_osc_Ordersdelivery_street_address = 'delivery_street_address';
  fld_osc_Ordersdelivery_suburb = 'delivery_suburb';
  fld_osc_Ordersdelivery_city = 'delivery_city';
  fld_osc_Ordersdelivery_postcode = 'delivery_postcode';
  fld_osc_Ordersdelivery_state = 'delivery_state';
  fld_osc_Ordersdelivery_country = 'delivery_country';
  fld_osc_Ordersdelivery_telephone = 'delivery_telephone';
  fld_osc_Orderslast_modified = 'last_modified';
  fld_osc_Ordersdate_purchased = 'date_purchased';
  fld_osc_Ordersorders_status = 'orders_status';
  fld_osc_Ordersorders_date_finished = 'orders_date_finished';
  fld_osc_Orderscomments = 'comments';
  fld_osc_Ordersrdx_ship_date = 'rdx_ship_date';
  fld_osc_Ordersrdx_referencia_cliente = 'rdx_referencia_cliente';

  { osc_Orders field indexes }
  idx_osc_Ordersorders_id = 0;
  idx_osc_Ordersrdx_orders_id_local = 1;
  idx_osc_Orderscustomers_id = 2;
  idx_osc_Ordersrdx_customers_id_local = 3;
  idx_osc_Ordersdelivery_name = 4;
  idx_osc_Ordersdelivery_company = 5;
  idx_osc_Ordersdelivery_street_address = 6;
  idx_osc_Ordersdelivery_suburb = 7;
  idx_osc_Ordersdelivery_city = 8;
  idx_osc_Ordersdelivery_postcode = 9;
  idx_osc_Ordersdelivery_state = 10;
  idx_osc_Ordersdelivery_country = 11;
  idx_osc_Ordersdelivery_telephone = 12;
  idx_osc_Orderslast_modified = 13;
  idx_osc_Ordersdate_purchased = 14;
  idx_osc_Ordersorders_status = 15;
  idx_osc_Ordersorders_date_finished = 16;
  idx_osc_Orderscomments = 17;
  idx_osc_Ordersrdx_ship_date = 18;
  idx_osc_Ordersrdx_referencia_cliente = 19;

  { osc_Orders_products fields }
  fld_osc_Orders_productsorders_products_id = 'orders_products_id';
  fld_osc_Orders_productsorders_id = 'orders_id';
  fld_osc_Orders_productsproducts_id = 'products_id';
  fld_osc_Orders_productsrdx_products_id_local = 'rdx_products_id_local';
  fld_osc_Orders_productsproducts_model = 'products_model';
  fld_osc_Orders_productsproducts_name = 'products_name';
  fld_osc_Orders_productsproducts_price = 'products_price';
  fld_osc_Orders_productsfinal_price = 'final_price';
  fld_osc_Orders_productsproducts_tax = 'products_tax';
  fld_osc_Orders_productsproducts_quantity = 'products_quantity';

  { osc_Orders_products field indexes }
  idx_osc_Orders_productsorders_products_id = 0;
  idx_osc_Orders_productsorders_id = 1;
  idx_osc_Orders_productsproducts_id = 2;
  idx_osc_Orders_productsrdx_products_id_local = 3;
  idx_osc_Orders_productsproducts_model = 4;
  idx_osc_Orders_productsproducts_name = 5;
  idx_osc_Orders_productsproducts_price = 6;
  idx_osc_Orders_productsfinal_price = 7;
  idx_osc_Orders_productsproducts_tax = 8;
  idx_osc_Orders_productsproducts_quantity = 9;

  { osc_Orders_status_history fields }
  fld_osc_Orders_status_historyorders_status_history_id = 'orders_status_history_id';
  fld_osc_Orders_status_historyorders_id = 'orders_id';
  fld_osc_Orders_status_historyrdx_orders_id_local = 'rdx_orders_id_local';
  fld_osc_Orders_status_historyorders_status_id = 'orders_status_id';
  fld_osc_Orders_status_historydate_added = 'date_added';
  fld_osc_Orders_status_historycustomer_notified = 'customer_notified';
  fld_osc_Orders_status_historycomments = 'comments';

  { osc_Orders_status_history field indexes }
  idx_osc_Orders_status_historyorders_status_history_id = 0;
  idx_osc_Orders_status_historyorders_id = 1;
  idx_osc_Orders_status_historyrdx_orders_id_local = 2;
  idx_osc_Orders_status_historyorders_status_id = 3;
  idx_osc_Orders_status_historydate_added = 4;
  idx_osc_Orders_status_historycustomer_notified = 5;
  idx_osc_Orders_status_historycomments = 6;

type
  { Iosc_Customers }
  Iosc_Customers = interface(IDAStronglyTypedDataTable)
  ['{792E030C-A2E7-4D16-8FA7-F07B4D885163}']
    { Property getters and setters }
    function Getcustomers_idValue: Integer;
    procedure Setcustomers_idValue(const aValue: Integer);
    function Getcustomers_firstnameValue: String;
    procedure Setcustomers_firstnameValue(const aValue: String);
    function Getcustomers_lastnameValue: String;
    procedure Setcustomers_lastnameValue(const aValue: String);
    function Getcustomers_email_addressValue: String;
    procedure Setcustomers_email_addressValue(const aValue: String);
    function Getcustomers_default_address_idValue: Integer;
    procedure Setcustomers_default_address_idValue(const aValue: Integer);
    function Getcustomers_telephoneValue: String;
    procedure Setcustomers_telephoneValue(const aValue: String);
    function Getcustomers_faxValue: String;
    procedure Setcustomers_faxValue(const aValue: String);
    function Getcustomers_passwordValue: String;
    procedure Setcustomers_passwordValue(const aValue: String);
    function Getrdx_customers_id_localValue: Integer;
    procedure Setrdx_customers_id_localValue(const aValue: Integer);
    function Getdate_account_createdValue: DateTime;
    procedure Setdate_account_createdValue(const aValue: DateTime);
    function Getdate_account_last_modifiedValue: DateTime;
    procedure Setdate_account_last_modifiedValue(const aValue: DateTime);


    { Properties }
    property customers_id: Integer read Getcustomers_idValue write Setcustomers_idValue;
    property customers_firstname: String read Getcustomers_firstnameValue write Setcustomers_firstnameValue;
    property customers_lastname: String read Getcustomers_lastnameValue write Setcustomers_lastnameValue;
    property customers_email_address: String read Getcustomers_email_addressValue write Setcustomers_email_addressValue;
    property customers_default_address_id: Integer read Getcustomers_default_address_idValue write Setcustomers_default_address_idValue;
    property customers_telephone: String read Getcustomers_telephoneValue write Setcustomers_telephoneValue;
    property customers_fax: String read Getcustomers_faxValue write Setcustomers_faxValue;
    property customers_password: String read Getcustomers_passwordValue write Setcustomers_passwordValue;
    property rdx_customers_id_local: Integer read Getrdx_customers_id_localValue write Setrdx_customers_id_localValue;
    property date_account_created: DateTime read Getdate_account_createdValue write Setdate_account_createdValue;
    property date_account_last_modified: DateTime read Getdate_account_last_modifiedValue write Setdate_account_last_modifiedValue;
  end;

  { Tosc_CustomersDataTableRules }
  Tosc_CustomersDataTableRules = class(TDADataTableRules, Iosc_Customers)
  private
  protected
    { Property getters and setters }
    function Getcustomers_idValue: Integer; virtual;
    procedure Setcustomers_idValue(const aValue: Integer); virtual;
    function Getcustomers_firstnameValue: String; virtual;
    procedure Setcustomers_firstnameValue(const aValue: String); virtual;
    function Getcustomers_lastnameValue: String; virtual;
    procedure Setcustomers_lastnameValue(const aValue: String); virtual;
    function Getcustomers_email_addressValue: String; virtual;
    procedure Setcustomers_email_addressValue(const aValue: String); virtual;
    function Getcustomers_default_address_idValue: Integer; virtual;
    procedure Setcustomers_default_address_idValue(const aValue: Integer); virtual;
    function Getcustomers_telephoneValue: String; virtual;
    procedure Setcustomers_telephoneValue(const aValue: String); virtual;
    function Getcustomers_faxValue: String; virtual;
    procedure Setcustomers_faxValue(const aValue: String); virtual;
    function Getcustomers_passwordValue: String; virtual;
    procedure Setcustomers_passwordValue(const aValue: String); virtual;
    function Getrdx_customers_id_localValue: Integer; virtual;
    procedure Setrdx_customers_id_localValue(const aValue: Integer); virtual;
    function Getdate_account_createdValue: DateTime; virtual;
    procedure Setdate_account_createdValue(const aValue: DateTime); virtual;
    function Getdate_account_last_modifiedValue: DateTime; virtual;
    procedure Setdate_account_last_modifiedValue(const aValue: DateTime); virtual;

    { Properties }
    property customers_id: Integer read Getcustomers_idValue write Setcustomers_idValue;
    property customers_firstname: String read Getcustomers_firstnameValue write Setcustomers_firstnameValue;
    property customers_lastname: String read Getcustomers_lastnameValue write Setcustomers_lastnameValue;
    property customers_email_address: String read Getcustomers_email_addressValue write Setcustomers_email_addressValue;
    property customers_default_address_id: Integer read Getcustomers_default_address_idValue write Setcustomers_default_address_idValue;
    property customers_telephone: String read Getcustomers_telephoneValue write Setcustomers_telephoneValue;
    property customers_fax: String read Getcustomers_faxValue write Setcustomers_faxValue;
    property customers_password: String read Getcustomers_passwordValue write Setcustomers_passwordValue;
    property rdx_customers_id_local: Integer read Getrdx_customers_id_localValue write Setrdx_customers_id_localValue;
    property date_account_created: DateTime read Getdate_account_createdValue write Setdate_account_createdValue;
    property date_account_last_modified: DateTime read Getdate_account_last_modifiedValue write Setdate_account_last_modifiedValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IGetLastID }
  IGetLastID = interface(IDAStronglyTypedDataTable)
  ['{0959DC32-2393-4762-8833-AAAB9709ABD0}']
    { Property getters and setters }
    function Getlast_idValue: Integer;
    procedure Setlast_idValue(const aValue: Integer);


    { Properties }
    property last_id: Integer read Getlast_idValue write Setlast_idValue;
  end;

  { TGetLastIDDataTableRules }
  TGetLastIDDataTableRules = class(TDADataTableRules, IGetLastID)
  private
  protected
    { Property getters and setters }
    function Getlast_idValue: Integer; virtual;
    procedure Setlast_idValue(const aValue: Integer); virtual;

    { Properties }
    property last_id: Integer read Getlast_idValue write Setlast_idValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { Iosc_AddressBook }
  Iosc_AddressBook = interface(IDAStronglyTypedDataTable)
  ['{E4E76431-F6F7-4A63-82B6-9F06ADD40282}']
    { Property getters and setters }
    function Getaddress_book_idValue: Integer;
    procedure Setaddress_book_idValue(const aValue: Integer);
    function Getcustomers_idValue: Integer;
    procedure Setcustomers_idValue(const aValue: Integer);
    function Getentry_genderValue: String;
    procedure Setentry_genderValue(const aValue: String);
    function Getentry_companyValue: String;
    procedure Setentry_companyValue(const aValue: String);
    function Getentry_firstnameValue: String;
    procedure Setentry_firstnameValue(const aValue: String);
    function Getentry_lastnameValue: String;
    procedure Setentry_lastnameValue(const aValue: String);
    function Getentry_street_addressValue: String;
    procedure Setentry_street_addressValue(const aValue: String);
    function Getentry_suburbValue: String;
    procedure Setentry_suburbValue(const aValue: String);
    function Getentry_postcodeValue: String;
    procedure Setentry_postcodeValue(const aValue: String);
    function Getentry_cityValue: String;
    procedure Setentry_cityValue(const aValue: String);
    function Getentry_stateValue: String;
    procedure Setentry_stateValue(const aValue: String);
    function Getentry_country_idValue: Integer;
    procedure Setentry_country_idValue(const aValue: Integer);
    function Getentry_zone_idValue: Integer;
    procedure Setentry_zone_idValue(const aValue: Integer);
    function Getentry_telephoneValue: String;
    procedure Setentry_telephoneValue(const aValue: String);
    function Getrdx_address_book_id_localValue: Integer;
    procedure Setrdx_address_book_id_localValue(const aValue: Integer);


    { Properties }
    property address_book_id: Integer read Getaddress_book_idValue write Setaddress_book_idValue;
    property customers_id: Integer read Getcustomers_idValue write Setcustomers_idValue;
    property entry_gender: String read Getentry_genderValue write Setentry_genderValue;
    property entry_company: String read Getentry_companyValue write Setentry_companyValue;
    property entry_firstname: String read Getentry_firstnameValue write Setentry_firstnameValue;
    property entry_lastname: String read Getentry_lastnameValue write Setentry_lastnameValue;
    property entry_street_address: String read Getentry_street_addressValue write Setentry_street_addressValue;
    property entry_suburb: String read Getentry_suburbValue write Setentry_suburbValue;
    property entry_postcode: String read Getentry_postcodeValue write Setentry_postcodeValue;
    property entry_city: String read Getentry_cityValue write Setentry_cityValue;
    property entry_state: String read Getentry_stateValue write Setentry_stateValue;
    property entry_country_id: Integer read Getentry_country_idValue write Setentry_country_idValue;
    property entry_zone_id: Integer read Getentry_zone_idValue write Setentry_zone_idValue;
    property entry_telephone: String read Getentry_telephoneValue write Setentry_telephoneValue;
    property rdx_address_book_id_local: Integer read Getrdx_address_book_id_localValue write Setrdx_address_book_id_localValue;
  end;

  { Tosc_AddressBookDataTableRules }
  Tosc_AddressBookDataTableRules = class(TDADataTableRules, Iosc_AddressBook)
  private
  protected
    { Property getters and setters }
    function Getaddress_book_idValue: Integer; virtual;
    procedure Setaddress_book_idValue(const aValue: Integer); virtual;
    function Getcustomers_idValue: Integer; virtual;
    procedure Setcustomers_idValue(const aValue: Integer); virtual;
    function Getentry_genderValue: String; virtual;
    procedure Setentry_genderValue(const aValue: String); virtual;
    function Getentry_companyValue: String; virtual;
    procedure Setentry_companyValue(const aValue: String); virtual;
    function Getentry_firstnameValue: String; virtual;
    procedure Setentry_firstnameValue(const aValue: String); virtual;
    function Getentry_lastnameValue: String; virtual;
    procedure Setentry_lastnameValue(const aValue: String); virtual;
    function Getentry_street_addressValue: String; virtual;
    procedure Setentry_street_addressValue(const aValue: String); virtual;
    function Getentry_suburbValue: String; virtual;
    procedure Setentry_suburbValue(const aValue: String); virtual;
    function Getentry_postcodeValue: String; virtual;
    procedure Setentry_postcodeValue(const aValue: String); virtual;
    function Getentry_cityValue: String; virtual;
    procedure Setentry_cityValue(const aValue: String); virtual;
    function Getentry_stateValue: String; virtual;
    procedure Setentry_stateValue(const aValue: String); virtual;
    function Getentry_country_idValue: Integer; virtual;
    procedure Setentry_country_idValue(const aValue: Integer); virtual;
    function Getentry_zone_idValue: Integer; virtual;
    procedure Setentry_zone_idValue(const aValue: Integer); virtual;
    function Getentry_telephoneValue: String; virtual;
    procedure Setentry_telephoneValue(const aValue: String); virtual;
    function Getrdx_address_book_id_localValue: Integer; virtual;
    procedure Setrdx_address_book_id_localValue(const aValue: Integer); virtual;

    { Properties }
    property address_book_id: Integer read Getaddress_book_idValue write Setaddress_book_idValue;
    property customers_id: Integer read Getcustomers_idValue write Setcustomers_idValue;
    property entry_gender: String read Getentry_genderValue write Setentry_genderValue;
    property entry_company: String read Getentry_companyValue write Setentry_companyValue;
    property entry_firstname: String read Getentry_firstnameValue write Setentry_firstnameValue;
    property entry_lastname: String read Getentry_lastnameValue write Setentry_lastnameValue;
    property entry_street_address: String read Getentry_street_addressValue write Setentry_street_addressValue;
    property entry_suburb: String read Getentry_suburbValue write Setentry_suburbValue;
    property entry_postcode: String read Getentry_postcodeValue write Setentry_postcodeValue;
    property entry_city: String read Getentry_cityValue write Setentry_cityValue;
    property entry_state: String read Getentry_stateValue write Setentry_stateValue;
    property entry_country_id: Integer read Getentry_country_idValue write Setentry_country_idValue;
    property entry_zone_id: Integer read Getentry_zone_idValue write Setentry_zone_idValue;
    property entry_telephone: String read Getentry_telephoneValue write Setentry_telephoneValue;
    property rdx_address_book_id_local: Integer read Getrdx_address_book_id_localValue write Setrdx_address_book_id_localValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { ITiendaWeb }
  ITiendaWeb = interface(IDAStronglyTypedDataTable)
  ['{2628FD76-4006-48A1-8F9C-3B207C38851E}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetTIENDA_ACTIVAValue: Integer;
    procedure SetTIENDA_ACTIVAValue(const aValue: Integer);
    function GetBDSERVERValue: String;
    procedure SetBDSERVERValue(const aValue: String);
    function GetBDPORTValue: String;
    procedure SetBDPORTValue(const aValue: String);
    function GetBDNAMEValue: String;
    procedure SetBDNAMEValue(const aValue: String);
    function GetBDUSERValue: String;
    procedure SetBDUSERValue(const aValue: String);
    function GetBDPASSValue: String;
    procedure SetBDPASSValue(const aValue: String);
    function GetULTIMA_ACTUALIZACIONValue: DateTime;
    procedure SetULTIMA_ACTUALIZACIONValue(const aValue: DateTime);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property TIENDA_ACTIVA: Integer read GetTIENDA_ACTIVAValue write SetTIENDA_ACTIVAValue;
    property BDSERVER: String read GetBDSERVERValue write SetBDSERVERValue;
    property BDPORT: String read GetBDPORTValue write SetBDPORTValue;
    property BDNAME: String read GetBDNAMEValue write SetBDNAMEValue;
    property BDUSER: String read GetBDUSERValue write SetBDUSERValue;
    property BDPASS: String read GetBDPASSValue write SetBDPASSValue;
    property ULTIMA_ACTUALIZACION: DateTime read GetULTIMA_ACTUALIZACIONValue write SetULTIMA_ACTUALIZACIONValue;
  end;

  { TTiendaWebDataTableRules }
  TTiendaWebDataTableRules = class(TDADataTableRules, ITiendaWeb)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetTIENDA_ACTIVAValue: Integer; virtual;
    procedure SetTIENDA_ACTIVAValue(const aValue: Integer); virtual;
    function GetBDSERVERValue: String; virtual;
    procedure SetBDSERVERValue(const aValue: String); virtual;
    function GetBDPORTValue: String; virtual;
    procedure SetBDPORTValue(const aValue: String); virtual;
    function GetBDNAMEValue: String; virtual;
    procedure SetBDNAMEValue(const aValue: String); virtual;
    function GetBDUSERValue: String; virtual;
    procedure SetBDUSERValue(const aValue: String); virtual;
    function GetBDPASSValue: String; virtual;
    procedure SetBDPASSValue(const aValue: String); virtual;
    function GetULTIMA_ACTUALIZACIONValue: DateTime; virtual;
    procedure SetULTIMA_ACTUALIZACIONValue(const aValue: DateTime); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property TIENDA_ACTIVA: Integer read GetTIENDA_ACTIVAValue write SetTIENDA_ACTIVAValue;
    property BDSERVER: String read GetBDSERVERValue write SetBDSERVERValue;
    property BDPORT: String read GetBDPORTValue write SetBDPORTValue;
    property BDNAME: String read GetBDNAMEValue write SetBDNAMEValue;
    property BDUSER: String read GetBDUSERValue write SetBDUSERValue;
    property BDPASS: String read GetBDPASSValue write SetBDPASSValue;
    property ULTIMA_ACTUALIZACION: DateTime read GetULTIMA_ACTUALIZACIONValue write SetULTIMA_ACTUALIZACIONValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { Iosc_Manufacturers }
  Iosc_Manufacturers = interface(IDAStronglyTypedDataTable)
  ['{9E826199-2387-4028-9340-85BD7C3AC6A5}']
    { Property getters and setters }
    function Getmanufacturers_idValue: Integer;
    procedure Setmanufacturers_idValue(const aValue: Integer);
    function Getmanufacturers_nameValue: String;
    procedure Setmanufacturers_nameValue(const aValue: String);
    function Getmanufacturers_imageValue: String;
    procedure Setmanufacturers_imageValue(const aValue: String);
    function Getdate_addedValue: DateTime;
    procedure Setdate_addedValue(const aValue: DateTime);
    function Getlast_modifiedValue: DateTime;
    procedure Setlast_modifiedValue(const aValue: DateTime);
    function Getrdx_manufacturers_id_localValue: Integer;
    procedure Setrdx_manufacturers_id_localValue(const aValue: Integer);


    { Properties }
    property manufacturers_id: Integer read Getmanufacturers_idValue write Setmanufacturers_idValue;
    property manufacturers_name: String read Getmanufacturers_nameValue write Setmanufacturers_nameValue;
    property manufacturers_image: String read Getmanufacturers_imageValue write Setmanufacturers_imageValue;
    property date_added: DateTime read Getdate_addedValue write Setdate_addedValue;
    property last_modified: DateTime read Getlast_modifiedValue write Setlast_modifiedValue;
    property rdx_manufacturers_id_local: Integer read Getrdx_manufacturers_id_localValue write Setrdx_manufacturers_id_localValue;
  end;

  { Tosc_ManufacturersDataTableRules }
  Tosc_ManufacturersDataTableRules = class(TDADataTableRules, Iosc_Manufacturers)
  private
  protected
    { Property getters and setters }
    function Getmanufacturers_idValue: Integer; virtual;
    procedure Setmanufacturers_idValue(const aValue: Integer); virtual;
    function Getmanufacturers_nameValue: String; virtual;
    procedure Setmanufacturers_nameValue(const aValue: String); virtual;
    function Getmanufacturers_imageValue: String; virtual;
    procedure Setmanufacturers_imageValue(const aValue: String); virtual;
    function Getdate_addedValue: DateTime; virtual;
    procedure Setdate_addedValue(const aValue: DateTime); virtual;
    function Getlast_modifiedValue: DateTime; virtual;
    procedure Setlast_modifiedValue(const aValue: DateTime); virtual;
    function Getrdx_manufacturers_id_localValue: Integer; virtual;
    procedure Setrdx_manufacturers_id_localValue(const aValue: Integer); virtual;

    { Properties }
    property manufacturers_id: Integer read Getmanufacturers_idValue write Setmanufacturers_idValue;
    property manufacturers_name: String read Getmanufacturers_nameValue write Setmanufacturers_nameValue;
    property manufacturers_image: String read Getmanufacturers_imageValue write Setmanufacturers_imageValue;
    property date_added: DateTime read Getdate_addedValue write Setdate_addedValue;
    property last_modified: DateTime read Getlast_modifiedValue write Setlast_modifiedValue;
    property rdx_manufacturers_id_local: Integer read Getrdx_manufacturers_id_localValue write Setrdx_manufacturers_id_localValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  {
  Esta tabla es sólo de consulta
  }
  { Iosc_Languages }
  Iosc_Languages = interface(IDAStronglyTypedDataTable)
  ['{38AD7122-1E0E-435A-B95A-DE54C35058AD}']
    { Property getters and setters }
    function Getlanguages_idValue: Integer;
    procedure Setlanguages_idValue(const aValue: Integer);
    function GetnameValue: String;
    procedure SetnameValue(const aValue: String);
    function GetcodeValue: String;
    procedure SetcodeValue(const aValue: String);
    function GetimageValue: String;
    procedure SetimageValue(const aValue: String);
    function GetdirectoryValue: String;
    procedure SetdirectoryValue(const aValue: String);
    function Getsort_orderValue: Integer;
    procedure Setsort_orderValue(const aValue: Integer);


    { Properties }
    property languages_id: Integer read Getlanguages_idValue write Setlanguages_idValue;
    property name: String read GetnameValue write SetnameValue;
    property code: String read GetcodeValue write SetcodeValue;
    property image: String read GetimageValue write SetimageValue;
    property directory: String read GetdirectoryValue write SetdirectoryValue;
    property sort_order: Integer read Getsort_orderValue write Setsort_orderValue;
  end;

  { Tosc_LanguagesDataTableRules }
  Tosc_LanguagesDataTableRules = class(TDADataTableRules, Iosc_Languages)
  private
  protected
    { Property getters and setters }
    function Getlanguages_idValue: Integer; virtual;
    procedure Setlanguages_idValue(const aValue: Integer); virtual;
    function GetnameValue: String; virtual;
    procedure SetnameValue(const aValue: String); virtual;
    function GetcodeValue: String; virtual;
    procedure SetcodeValue(const aValue: String); virtual;
    function GetimageValue: String; virtual;
    procedure SetimageValue(const aValue: String); virtual;
    function GetdirectoryValue: String; virtual;
    procedure SetdirectoryValue(const aValue: String); virtual;
    function Getsort_orderValue: Integer; virtual;
    procedure Setsort_orderValue(const aValue: Integer); virtual;

    { Properties }
    property languages_id: Integer read Getlanguages_idValue write Setlanguages_idValue;
    property name: String read GetnameValue write SetnameValue;
    property code: String read GetcodeValue write SetcodeValue;
    property image: String read GetimageValue write SetimageValue;
    property directory: String read GetdirectoryValue write SetdirectoryValue;
    property sort_order: Integer read Getsort_orderValue write Setsort_orderValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { Iosc_Products }
  Iosc_Products = interface(IDAStronglyTypedDataTable)
  ['{98315B37-BFF8-4AF1-A1FF-1138DEE85D39}']
    { Property getters and setters }
    function Getproducts_idValue: Integer;
    procedure Setproducts_idValue(const aValue: Integer);
    function Getproducts_nameValue: String;
    procedure Setproducts_nameValue(const aValue: String);
    function Getproducts_descriptionValue: IROStrings;
    procedure Setproducts_descriptionValue(const aValue: IROStrings);
    function Getproducts_modelValue: String;
    procedure Setproducts_modelValue(const aValue: String);
    function Getproducts_date_addedValue: DateTime;
    procedure Setproducts_date_addedValue(const aValue: DateTime);
    function Getproducts_last_modifiedValue: DateTime;
    procedure Setproducts_last_modifiedValue(const aValue: DateTime);
    function Getproducts_statusValue: Integer;
    procedure Setproducts_statusValue(const aValue: Integer);
    function Getmanufacturers_idValue: Integer;
    procedure Setmanufacturers_idValue(const aValue: Integer);
    function Getrdx_products_id_localValue: Integer;
    procedure Setrdx_products_id_localValue(const aValue: Integer);


    { Properties }
    property products_id: Integer read Getproducts_idValue write Setproducts_idValue;
    property products_name: String read Getproducts_nameValue write Setproducts_nameValue;
    property products_description: IROStrings read Getproducts_descriptionValue write Setproducts_descriptionValue;
    property products_model: String read Getproducts_modelValue write Setproducts_modelValue;
    property products_date_added: DateTime read Getproducts_date_addedValue write Setproducts_date_addedValue;
    property products_last_modified: DateTime read Getproducts_last_modifiedValue write Setproducts_last_modifiedValue;
    property products_status: Integer read Getproducts_statusValue write Setproducts_statusValue;
    property manufacturers_id: Integer read Getmanufacturers_idValue write Setmanufacturers_idValue;
    property rdx_products_id_local: Integer read Getrdx_products_id_localValue write Setrdx_products_id_localValue;
  end;

  { Tosc_ProductsDataTableRules }
  Tosc_ProductsDataTableRules = class(TDADataTableRules, Iosc_Products)
  private
  protected
    { Property getters and setters }
    function Getproducts_idValue: Integer; virtual;
    procedure Setproducts_idValue(const aValue: Integer); virtual;
    function Getproducts_nameValue: String; virtual;
    procedure Setproducts_nameValue(const aValue: String); virtual;
    function Getproducts_descriptionValue: IROStrings; virtual;
    procedure Setproducts_descriptionValue(const aValue: IROStrings); virtual;
    function Getproducts_modelValue: String; virtual;
    procedure Setproducts_modelValue(const aValue: String); virtual;
    function Getproducts_date_addedValue: DateTime; virtual;
    procedure Setproducts_date_addedValue(const aValue: DateTime); virtual;
    function Getproducts_last_modifiedValue: DateTime; virtual;
    procedure Setproducts_last_modifiedValue(const aValue: DateTime); virtual;
    function Getproducts_statusValue: Integer; virtual;
    procedure Setproducts_statusValue(const aValue: Integer); virtual;
    function Getmanufacturers_idValue: Integer; virtual;
    procedure Setmanufacturers_idValue(const aValue: Integer); virtual;
    function Getrdx_products_id_localValue: Integer; virtual;
    procedure Setrdx_products_id_localValue(const aValue: Integer); virtual;

    { Properties }
    property products_id: Integer read Getproducts_idValue write Setproducts_idValue;
    property products_name: String read Getproducts_nameValue write Setproducts_nameValue;
    property products_description: IROStrings read Getproducts_descriptionValue write Setproducts_descriptionValue;
    property products_model: String read Getproducts_modelValue write Setproducts_modelValue;
    property products_date_added: DateTime read Getproducts_date_addedValue write Setproducts_date_addedValue;
    property products_last_modified: DateTime read Getproducts_last_modifiedValue write Setproducts_last_modifiedValue;
    property products_status: Integer read Getproducts_statusValue write Setproducts_statusValue;
    property manufacturers_id: Integer read Getmanufacturers_idValue write Setmanufacturers_idValue;
    property rdx_products_id_local: Integer read Getrdx_products_id_localValue write Setrdx_products_id_localValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { Iosc_Orders }
  Iosc_Orders = interface(IDAStronglyTypedDataTable)
  ['{87156214-5768-45E2-9CFE-26CFED79AF95}']
    { Property getters and setters }
    function Getorders_idValue: Integer;
    procedure Setorders_idValue(const aValue: Integer);
    function Getrdx_orders_id_localValue: Integer;
    procedure Setrdx_orders_id_localValue(const aValue: Integer);
    function Getcustomers_idValue: Integer;
    procedure Setcustomers_idValue(const aValue: Integer);
    function Getrdx_customers_id_localValue: Integer;
    procedure Setrdx_customers_id_localValue(const aValue: Integer);
    function Getdelivery_nameValue: String;
    procedure Setdelivery_nameValue(const aValue: String);
    function Getdelivery_companyValue: String;
    procedure Setdelivery_companyValue(const aValue: String);
    function Getdelivery_street_addressValue: String;
    procedure Setdelivery_street_addressValue(const aValue: String);
    function Getdelivery_suburbValue: String;
    procedure Setdelivery_suburbValue(const aValue: String);
    function Getdelivery_cityValue: String;
    procedure Setdelivery_cityValue(const aValue: String);
    function Getdelivery_postcodeValue: String;
    procedure Setdelivery_postcodeValue(const aValue: String);
    function Getdelivery_stateValue: String;
    procedure Setdelivery_stateValue(const aValue: String);
    function Getdelivery_countryValue: String;
    procedure Setdelivery_countryValue(const aValue: String);
    function Getdelivery_telephoneValue: String;
    procedure Setdelivery_telephoneValue(const aValue: String);
    function Getlast_modifiedValue: DateTime;
    procedure Setlast_modifiedValue(const aValue: DateTime);
    function Getdate_purchasedValue: DateTime;
    procedure Setdate_purchasedValue(const aValue: DateTime);
    function Getorders_statusValue: Integer;
    procedure Setorders_statusValue(const aValue: Integer);
    function Getorders_date_finishedValue: DateTime;
    procedure Setorders_date_finishedValue(const aValue: DateTime);
    function GetcommentsValue: IROStrings;
    procedure SetcommentsValue(const aValue: IROStrings);
    function Getrdx_ship_dateValue: DateTime;
    procedure Setrdx_ship_dateValue(const aValue: DateTime);
    function Getrdx_referencia_clienteValue: String;
    procedure Setrdx_referencia_clienteValue(const aValue: String);


    { Properties }
    property orders_id: Integer read Getorders_idValue write Setorders_idValue;
    property rdx_orders_id_local: Integer read Getrdx_orders_id_localValue write Setrdx_orders_id_localValue;
    property customers_id: Integer read Getcustomers_idValue write Setcustomers_idValue;
    property rdx_customers_id_local: Integer read Getrdx_customers_id_localValue write Setrdx_customers_id_localValue;
    property delivery_name: String read Getdelivery_nameValue write Setdelivery_nameValue;
    property delivery_company: String read Getdelivery_companyValue write Setdelivery_companyValue;
    property delivery_street_address: String read Getdelivery_street_addressValue write Setdelivery_street_addressValue;
    property delivery_suburb: String read Getdelivery_suburbValue write Setdelivery_suburbValue;
    property delivery_city: String read Getdelivery_cityValue write Setdelivery_cityValue;
    property delivery_postcode: String read Getdelivery_postcodeValue write Setdelivery_postcodeValue;
    property delivery_state: String read Getdelivery_stateValue write Setdelivery_stateValue;
    property delivery_country: String read Getdelivery_countryValue write Setdelivery_countryValue;
    property delivery_telephone: String read Getdelivery_telephoneValue write Setdelivery_telephoneValue;
    property last_modified: DateTime read Getlast_modifiedValue write Setlast_modifiedValue;
    property date_purchased: DateTime read Getdate_purchasedValue write Setdate_purchasedValue;
    property orders_status: Integer read Getorders_statusValue write Setorders_statusValue;
    property orders_date_finished: DateTime read Getorders_date_finishedValue write Setorders_date_finishedValue;
    property comments: IROStrings read GetcommentsValue write SetcommentsValue;
    property rdx_ship_date: DateTime read Getrdx_ship_dateValue write Setrdx_ship_dateValue;
    property rdx_referencia_cliente: String read Getrdx_referencia_clienteValue write Setrdx_referencia_clienteValue;
  end;

  { Tosc_OrdersDataTableRules }
  Tosc_OrdersDataTableRules = class(TDADataTableRules, Iosc_Orders)
  private
  protected
    { Property getters and setters }
    function Getorders_idValue: Integer; virtual;
    procedure Setorders_idValue(const aValue: Integer); virtual;
    function Getrdx_orders_id_localValue: Integer; virtual;
    procedure Setrdx_orders_id_localValue(const aValue: Integer); virtual;
    function Getcustomers_idValue: Integer; virtual;
    procedure Setcustomers_idValue(const aValue: Integer); virtual;
    function Getrdx_customers_id_localValue: Integer; virtual;
    procedure Setrdx_customers_id_localValue(const aValue: Integer); virtual;
    function Getdelivery_nameValue: String; virtual;
    procedure Setdelivery_nameValue(const aValue: String); virtual;
    function Getdelivery_companyValue: String; virtual;
    procedure Setdelivery_companyValue(const aValue: String); virtual;
    function Getdelivery_street_addressValue: String; virtual;
    procedure Setdelivery_street_addressValue(const aValue: String); virtual;
    function Getdelivery_suburbValue: String; virtual;
    procedure Setdelivery_suburbValue(const aValue: String); virtual;
    function Getdelivery_cityValue: String; virtual;
    procedure Setdelivery_cityValue(const aValue: String); virtual;
    function Getdelivery_postcodeValue: String; virtual;
    procedure Setdelivery_postcodeValue(const aValue: String); virtual;
    function Getdelivery_stateValue: String; virtual;
    procedure Setdelivery_stateValue(const aValue: String); virtual;
    function Getdelivery_countryValue: String; virtual;
    procedure Setdelivery_countryValue(const aValue: String); virtual;
    function Getdelivery_telephoneValue: String; virtual;
    procedure Setdelivery_telephoneValue(const aValue: String); virtual;
    function Getlast_modifiedValue: DateTime; virtual;
    procedure Setlast_modifiedValue(const aValue: DateTime); virtual;
    function Getdate_purchasedValue: DateTime; virtual;
    procedure Setdate_purchasedValue(const aValue: DateTime); virtual;
    function Getorders_statusValue: Integer; virtual;
    procedure Setorders_statusValue(const aValue: Integer); virtual;
    function Getorders_date_finishedValue: DateTime; virtual;
    procedure Setorders_date_finishedValue(const aValue: DateTime); virtual;
    function GetcommentsValue: IROStrings; virtual;
    procedure SetcommentsValue(const aValue: IROStrings); virtual;
    function Getrdx_ship_dateValue: DateTime; virtual;
    procedure Setrdx_ship_dateValue(const aValue: DateTime); virtual;
    function Getrdx_referencia_clienteValue: String; virtual;
    procedure Setrdx_referencia_clienteValue(const aValue: String); virtual;

    { Properties }
    property orders_id: Integer read Getorders_idValue write Setorders_idValue;
    property rdx_orders_id_local: Integer read Getrdx_orders_id_localValue write Setrdx_orders_id_localValue;
    property customers_id: Integer read Getcustomers_idValue write Setcustomers_idValue;
    property rdx_customers_id_local: Integer read Getrdx_customers_id_localValue write Setrdx_customers_id_localValue;
    property delivery_name: String read Getdelivery_nameValue write Setdelivery_nameValue;
    property delivery_company: String read Getdelivery_companyValue write Setdelivery_companyValue;
    property delivery_street_address: String read Getdelivery_street_addressValue write Setdelivery_street_addressValue;
    property delivery_suburb: String read Getdelivery_suburbValue write Setdelivery_suburbValue;
    property delivery_city: String read Getdelivery_cityValue write Setdelivery_cityValue;
    property delivery_postcode: String read Getdelivery_postcodeValue write Setdelivery_postcodeValue;
    property delivery_state: String read Getdelivery_stateValue write Setdelivery_stateValue;
    property delivery_country: String read Getdelivery_countryValue write Setdelivery_countryValue;
    property delivery_telephone: String read Getdelivery_telephoneValue write Setdelivery_telephoneValue;
    property last_modified: DateTime read Getlast_modifiedValue write Setlast_modifiedValue;
    property date_purchased: DateTime read Getdate_purchasedValue write Setdate_purchasedValue;
    property orders_status: Integer read Getorders_statusValue write Setorders_statusValue;
    property orders_date_finished: DateTime read Getorders_date_finishedValue write Setorders_date_finishedValue;
    property comments: IROStrings read GetcommentsValue write SetcommentsValue;
    property rdx_ship_date: DateTime read Getrdx_ship_dateValue write Setrdx_ship_dateValue;
    property rdx_referencia_cliente: String read Getrdx_referencia_clienteValue write Setrdx_referencia_clienteValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { Iosc_Orders_products }
  Iosc_Orders_products = interface(IDAStronglyTypedDataTable)
  ['{D2315455-C4D0-4F02-8A58-9E9F2E62AFD1}']
    { Property getters and setters }
    function Getorders_products_idValue: Integer;
    procedure Setorders_products_idValue(const aValue: Integer);
    function Getorders_idValue: Integer;
    procedure Setorders_idValue(const aValue: Integer);
    function Getproducts_idValue: Integer;
    procedure Setproducts_idValue(const aValue: Integer);
    function Getrdx_products_id_localValue: Integer;
    procedure Setrdx_products_id_localValue(const aValue: Integer);
    function Getproducts_modelValue: String;
    procedure Setproducts_modelValue(const aValue: String);
    function Getproducts_nameValue: String;
    procedure Setproducts_nameValue(const aValue: String);
    function Getproducts_priceValue: Float;
    procedure Setproducts_priceValue(const aValue: Float);
    function Getfinal_priceValue: Float;
    procedure Setfinal_priceValue(const aValue: Float);
    function Getproducts_taxValue: Float;
    procedure Setproducts_taxValue(const aValue: Float);
    function Getproducts_quantityValue: Integer;
    procedure Setproducts_quantityValue(const aValue: Integer);


    { Properties }
    property orders_products_id: Integer read Getorders_products_idValue write Setorders_products_idValue;
    property orders_id: Integer read Getorders_idValue write Setorders_idValue;
    property products_id: Integer read Getproducts_idValue write Setproducts_idValue;
    property rdx_products_id_local: Integer read Getrdx_products_id_localValue write Setrdx_products_id_localValue;
    property products_model: String read Getproducts_modelValue write Setproducts_modelValue;
    property products_name: String read Getproducts_nameValue write Setproducts_nameValue;
    property products_price: Float read Getproducts_priceValue write Setproducts_priceValue;
    property final_price: Float read Getfinal_priceValue write Setfinal_priceValue;
    property products_tax: Float read Getproducts_taxValue write Setproducts_taxValue;
    property products_quantity: Integer read Getproducts_quantityValue write Setproducts_quantityValue;
  end;

  { Tosc_Orders_productsDataTableRules }
  Tosc_Orders_productsDataTableRules = class(TDADataTableRules, Iosc_Orders_products)
  private
  protected
    { Property getters and setters }
    function Getorders_products_idValue: Integer; virtual;
    procedure Setorders_products_idValue(const aValue: Integer); virtual;
    function Getorders_idValue: Integer; virtual;
    procedure Setorders_idValue(const aValue: Integer); virtual;
    function Getproducts_idValue: Integer; virtual;
    procedure Setproducts_idValue(const aValue: Integer); virtual;
    function Getrdx_products_id_localValue: Integer; virtual;
    procedure Setrdx_products_id_localValue(const aValue: Integer); virtual;
    function Getproducts_modelValue: String; virtual;
    procedure Setproducts_modelValue(const aValue: String); virtual;
    function Getproducts_nameValue: String; virtual;
    procedure Setproducts_nameValue(const aValue: String); virtual;
    function Getproducts_priceValue: Float; virtual;
    procedure Setproducts_priceValue(const aValue: Float); virtual;
    function Getfinal_priceValue: Float; virtual;
    procedure Setfinal_priceValue(const aValue: Float); virtual;
    function Getproducts_taxValue: Float; virtual;
    procedure Setproducts_taxValue(const aValue: Float); virtual;
    function Getproducts_quantityValue: Integer; virtual;
    procedure Setproducts_quantityValue(const aValue: Integer); virtual;

    { Properties }
    property orders_products_id: Integer read Getorders_products_idValue write Setorders_products_idValue;
    property orders_id: Integer read Getorders_idValue write Setorders_idValue;
    property products_id: Integer read Getproducts_idValue write Setproducts_idValue;
    property rdx_products_id_local: Integer read Getrdx_products_id_localValue write Setrdx_products_id_localValue;
    property products_model: String read Getproducts_modelValue write Setproducts_modelValue;
    property products_name: String read Getproducts_nameValue write Setproducts_nameValue;
    property products_price: Float read Getproducts_priceValue write Setproducts_priceValue;
    property final_price: Float read Getfinal_priceValue write Setfinal_priceValue;
    property products_tax: Float read Getproducts_taxValue write Setproducts_taxValue;
    property products_quantity: Integer read Getproducts_quantityValue write Setproducts_quantityValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { Iosc_Orders_status_history }
  Iosc_Orders_status_history = interface(IDAStronglyTypedDataTable)
  ['{F31E06B0-560C-45EB-88B8-2FE328F5AF96}']
    { Property getters and setters }
    function Getorders_status_history_idValue: Integer;
    procedure Setorders_status_history_idValue(const aValue: Integer);
    function Getorders_idValue: Integer;
    procedure Setorders_idValue(const aValue: Integer);
    function Getrdx_orders_id_localValue: Integer;
    procedure Setrdx_orders_id_localValue(const aValue: Integer);
    function Getorders_status_idValue: Integer;
    procedure Setorders_status_idValue(const aValue: Integer);
    function Getdate_addedValue: DateTime;
    procedure Setdate_addedValue(const aValue: DateTime);
    function Getcustomer_notifiedValue: Integer;
    procedure Setcustomer_notifiedValue(const aValue: Integer);
    function GetcommentsValue: IROStrings;
    procedure SetcommentsValue(const aValue: IROStrings);


    { Properties }
    property orders_status_history_id: Integer read Getorders_status_history_idValue write Setorders_status_history_idValue;
    property orders_id: Integer read Getorders_idValue write Setorders_idValue;
    property rdx_orders_id_local: Integer read Getrdx_orders_id_localValue write Setrdx_orders_id_localValue;
    property orders_status_id: Integer read Getorders_status_idValue write Setorders_status_idValue;
    property date_added: DateTime read Getdate_addedValue write Setdate_addedValue;
    property customer_notified: Integer read Getcustomer_notifiedValue write Setcustomer_notifiedValue;
    property comments: IROStrings read GetcommentsValue write SetcommentsValue;
  end;

  { Tosc_Orders_status_historyDataTableRules }
  Tosc_Orders_status_historyDataTableRules = class(TDADataTableRules, Iosc_Orders_status_history)
  private
  protected
    { Property getters and setters }
    function Getorders_status_history_idValue: Integer; virtual;
    procedure Setorders_status_history_idValue(const aValue: Integer); virtual;
    function Getorders_idValue: Integer; virtual;
    procedure Setorders_idValue(const aValue: Integer); virtual;
    function Getrdx_orders_id_localValue: Integer; virtual;
    procedure Setrdx_orders_id_localValue(const aValue: Integer); virtual;
    function Getorders_status_idValue: Integer; virtual;
    procedure Setorders_status_idValue(const aValue: Integer); virtual;
    function Getdate_addedValue: DateTime; virtual;
    procedure Setdate_addedValue(const aValue: DateTime); virtual;
    function Getcustomer_notifiedValue: Integer; virtual;
    procedure Setcustomer_notifiedValue(const aValue: Integer); virtual;
    function GetcommentsValue: IROStrings; virtual;
    procedure SetcommentsValue(const aValue: IROStrings); virtual;

    { Properties }
    property orders_status_history_id: Integer read Getorders_status_history_idValue write Setorders_status_history_idValue;
    property orders_id: Integer read Getorders_idValue write Setorders_idValue;
    property rdx_orders_id_local: Integer read Getrdx_orders_id_localValue write Setrdx_orders_id_localValue;
    property orders_status_id: Integer read Getorders_status_idValue write Setorders_status_idValue;
    property date_added: DateTime read Getdate_addedValue write Setdate_addedValue;
    property customer_notified: Integer read Getcustomer_notifiedValue write Setcustomer_notifiedValue;
    property comments: IROStrings read GetcommentsValue write SetcommentsValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ Tosc_CustomersDataTableRules }
constructor Tosc_CustomersDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor Tosc_CustomersDataTableRules.Destroy;
begin
  inherited;
end;

function Tosc_CustomersDataTableRules.Getcustomers_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Customerscustomers_id].AsInteger;
end;

procedure Tosc_CustomersDataTableRules.Setcustomers_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Customerscustomers_id].AsInteger := aValue;
end;

function Tosc_CustomersDataTableRules.Getcustomers_firstnameValue: String;
begin
  result := DataTable.Fields[idx_osc_Customerscustomers_firstname].AsString;
end;

procedure Tosc_CustomersDataTableRules.Setcustomers_firstnameValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Customerscustomers_firstname].AsString := aValue;
end;

function Tosc_CustomersDataTableRules.Getcustomers_lastnameValue: String;
begin
  result := DataTable.Fields[idx_osc_Customerscustomers_lastname].AsString;
end;

procedure Tosc_CustomersDataTableRules.Setcustomers_lastnameValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Customerscustomers_lastname].AsString := aValue;
end;

function Tosc_CustomersDataTableRules.Getcustomers_email_addressValue: String;
begin
  result := DataTable.Fields[idx_osc_Customerscustomers_email_address].AsString;
end;

procedure Tosc_CustomersDataTableRules.Setcustomers_email_addressValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Customerscustomers_email_address].AsString := aValue;
end;

function Tosc_CustomersDataTableRules.Getcustomers_default_address_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Customerscustomers_default_address_id].AsInteger;
end;

procedure Tosc_CustomersDataTableRules.Setcustomers_default_address_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Customerscustomers_default_address_id].AsInteger := aValue;
end;

function Tosc_CustomersDataTableRules.Getcustomers_telephoneValue: String;
begin
  result := DataTable.Fields[idx_osc_Customerscustomers_telephone].AsString;
end;

procedure Tosc_CustomersDataTableRules.Setcustomers_telephoneValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Customerscustomers_telephone].AsString := aValue;
end;

function Tosc_CustomersDataTableRules.Getcustomers_faxValue: String;
begin
  result := DataTable.Fields[idx_osc_Customerscustomers_fax].AsString;
end;

procedure Tosc_CustomersDataTableRules.Setcustomers_faxValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Customerscustomers_fax].AsString := aValue;
end;

function Tosc_CustomersDataTableRules.Getcustomers_passwordValue: String;
begin
  result := DataTable.Fields[idx_osc_Customerscustomers_password].AsString;
end;

procedure Tosc_CustomersDataTableRules.Setcustomers_passwordValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Customerscustomers_password].AsString := aValue;
end;

function Tosc_CustomersDataTableRules.Getrdx_customers_id_localValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Customersrdx_customers_id_local].AsInteger;
end;

procedure Tosc_CustomersDataTableRules.Setrdx_customers_id_localValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Customersrdx_customers_id_local].AsInteger := aValue;
end;

function Tosc_CustomersDataTableRules.Getdate_account_createdValue: DateTime;
begin
  result := DataTable.Fields[idx_osc_Customersdate_account_created].AsDateTime;
end;

procedure Tosc_CustomersDataTableRules.Setdate_account_createdValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_osc_Customersdate_account_created].AsDateTime := aValue;
end;

function Tosc_CustomersDataTableRules.Getdate_account_last_modifiedValue: DateTime;
begin
  result := DataTable.Fields[idx_osc_Customersdate_account_last_modified].AsDateTime;
end;

procedure Tosc_CustomersDataTableRules.Setdate_account_last_modifiedValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_osc_Customersdate_account_last_modified].AsDateTime := aValue;
end;


{ TGetLastIDDataTableRules }
constructor TGetLastIDDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TGetLastIDDataTableRules.Destroy;
begin
  inherited;
end;

function TGetLastIDDataTableRules.Getlast_idValue: Integer;
begin
  result := DataTable.Fields[idx_GetLastIDlast_id].AsInteger;
end;

procedure TGetLastIDDataTableRules.Setlast_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_GetLastIDlast_id].AsInteger := aValue;
end;


{ Tosc_AddressBookDataTableRules }
constructor Tosc_AddressBookDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor Tosc_AddressBookDataTableRules.Destroy;
begin
  inherited;
end;

function Tosc_AddressBookDataTableRules.Getaddress_book_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_AddressBookaddress_book_id].AsInteger;
end;

procedure Tosc_AddressBookDataTableRules.Setaddress_book_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_AddressBookaddress_book_id].AsInteger := aValue;
end;

function Tosc_AddressBookDataTableRules.Getcustomers_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_AddressBookcustomers_id].AsInteger;
end;

procedure Tosc_AddressBookDataTableRules.Setcustomers_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_AddressBookcustomers_id].AsInteger := aValue;
end;

function Tosc_AddressBookDataTableRules.Getentry_genderValue: String;
begin
  result := DataTable.Fields[idx_osc_AddressBookentry_gender].AsString;
end;

procedure Tosc_AddressBookDataTableRules.Setentry_genderValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_AddressBookentry_gender].AsString := aValue;
end;

function Tosc_AddressBookDataTableRules.Getentry_companyValue: String;
begin
  result := DataTable.Fields[idx_osc_AddressBookentry_company].AsString;
end;

procedure Tosc_AddressBookDataTableRules.Setentry_companyValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_AddressBookentry_company].AsString := aValue;
end;

function Tosc_AddressBookDataTableRules.Getentry_firstnameValue: String;
begin
  result := DataTable.Fields[idx_osc_AddressBookentry_firstname].AsString;
end;

procedure Tosc_AddressBookDataTableRules.Setentry_firstnameValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_AddressBookentry_firstname].AsString := aValue;
end;

function Tosc_AddressBookDataTableRules.Getentry_lastnameValue: String;
begin
  result := DataTable.Fields[idx_osc_AddressBookentry_lastname].AsString;
end;

procedure Tosc_AddressBookDataTableRules.Setentry_lastnameValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_AddressBookentry_lastname].AsString := aValue;
end;

function Tosc_AddressBookDataTableRules.Getentry_street_addressValue: String;
begin
  result := DataTable.Fields[idx_osc_AddressBookentry_street_address].AsString;
end;

procedure Tosc_AddressBookDataTableRules.Setentry_street_addressValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_AddressBookentry_street_address].AsString := aValue;
end;

function Tosc_AddressBookDataTableRules.Getentry_suburbValue: String;
begin
  result := DataTable.Fields[idx_osc_AddressBookentry_suburb].AsString;
end;

procedure Tosc_AddressBookDataTableRules.Setentry_suburbValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_AddressBookentry_suburb].AsString := aValue;
end;

function Tosc_AddressBookDataTableRules.Getentry_postcodeValue: String;
begin
  result := DataTable.Fields[idx_osc_AddressBookentry_postcode].AsString;
end;

procedure Tosc_AddressBookDataTableRules.Setentry_postcodeValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_AddressBookentry_postcode].AsString := aValue;
end;

function Tosc_AddressBookDataTableRules.Getentry_cityValue: String;
begin
  result := DataTable.Fields[idx_osc_AddressBookentry_city].AsString;
end;

procedure Tosc_AddressBookDataTableRules.Setentry_cityValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_AddressBookentry_city].AsString := aValue;
end;

function Tosc_AddressBookDataTableRules.Getentry_stateValue: String;
begin
  result := DataTable.Fields[idx_osc_AddressBookentry_state].AsString;
end;

procedure Tosc_AddressBookDataTableRules.Setentry_stateValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_AddressBookentry_state].AsString := aValue;
end;

function Tosc_AddressBookDataTableRules.Getentry_country_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_AddressBookentry_country_id].AsInteger;
end;

procedure Tosc_AddressBookDataTableRules.Setentry_country_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_AddressBookentry_country_id].AsInteger := aValue;
end;

function Tosc_AddressBookDataTableRules.Getentry_zone_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_AddressBookentry_zone_id].AsInteger;
end;

procedure Tosc_AddressBookDataTableRules.Setentry_zone_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_AddressBookentry_zone_id].AsInteger := aValue;
end;

function Tosc_AddressBookDataTableRules.Getentry_telephoneValue: String;
begin
  result := DataTable.Fields[idx_osc_AddressBookentry_telephone].AsString;
end;

procedure Tosc_AddressBookDataTableRules.Setentry_telephoneValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_AddressBookentry_telephone].AsString := aValue;
end;

function Tosc_AddressBookDataTableRules.Getrdx_address_book_id_localValue: Integer;
begin
  result := DataTable.Fields[idx_osc_AddressBookrdx_address_book_id_local].AsInteger;
end;

procedure Tosc_AddressBookDataTableRules.Setrdx_address_book_id_localValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_AddressBookrdx_address_book_id_local].AsInteger := aValue;
end;


{ TTiendaWebDataTableRules }
constructor TTiendaWebDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TTiendaWebDataTableRules.Destroy;
begin
  inherited;
end;

function TTiendaWebDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_TiendaWebID].AsInteger;
end;

procedure TTiendaWebDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_TiendaWebID].AsInteger := aValue;
end;

function TTiendaWebDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_TiendaWebID_EMPRESA].AsInteger;
end;

procedure TTiendaWebDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_TiendaWebID_EMPRESA].AsInteger := aValue;
end;

function TTiendaWebDataTableRules.GetTIENDA_ACTIVAValue: Integer;
begin
  result := DataTable.Fields[idx_TiendaWebTIENDA_ACTIVA].AsInteger;
end;

procedure TTiendaWebDataTableRules.SetTIENDA_ACTIVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_TiendaWebTIENDA_ACTIVA].AsInteger := aValue;
end;

function TTiendaWebDataTableRules.GetBDSERVERValue: String;
begin
  result := DataTable.Fields[idx_TiendaWebBDSERVER].AsString;
end;

procedure TTiendaWebDataTableRules.SetBDSERVERValue(const aValue: String);
begin
  DataTable.Fields[idx_TiendaWebBDSERVER].AsString := aValue;
end;

function TTiendaWebDataTableRules.GetBDPORTValue: String;
begin
  result := DataTable.Fields[idx_TiendaWebBDPORT].AsString;
end;

procedure TTiendaWebDataTableRules.SetBDPORTValue(const aValue: String);
begin
  DataTable.Fields[idx_TiendaWebBDPORT].AsString := aValue;
end;

function TTiendaWebDataTableRules.GetBDNAMEValue: String;
begin
  result := DataTable.Fields[idx_TiendaWebBDNAME].AsString;
end;

procedure TTiendaWebDataTableRules.SetBDNAMEValue(const aValue: String);
begin
  DataTable.Fields[idx_TiendaWebBDNAME].AsString := aValue;
end;

function TTiendaWebDataTableRules.GetBDUSERValue: String;
begin
  result := DataTable.Fields[idx_TiendaWebBDUSER].AsString;
end;

procedure TTiendaWebDataTableRules.SetBDUSERValue(const aValue: String);
begin
  DataTable.Fields[idx_TiendaWebBDUSER].AsString := aValue;
end;

function TTiendaWebDataTableRules.GetBDPASSValue: String;
begin
  result := DataTable.Fields[idx_TiendaWebBDPASS].AsString;
end;

procedure TTiendaWebDataTableRules.SetBDPASSValue(const aValue: String);
begin
  DataTable.Fields[idx_TiendaWebBDPASS].AsString := aValue;
end;

function TTiendaWebDataTableRules.GetULTIMA_ACTUALIZACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_TiendaWebULTIMA_ACTUALIZACION].AsDateTime;
end;

procedure TTiendaWebDataTableRules.SetULTIMA_ACTUALIZACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_TiendaWebULTIMA_ACTUALIZACION].AsDateTime := aValue;
end;


{ Tosc_ManufacturersDataTableRules }
constructor Tosc_ManufacturersDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor Tosc_ManufacturersDataTableRules.Destroy;
begin
  inherited;
end;

function Tosc_ManufacturersDataTableRules.Getmanufacturers_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Manufacturersmanufacturers_id].AsInteger;
end;

procedure Tosc_ManufacturersDataTableRules.Setmanufacturers_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Manufacturersmanufacturers_id].AsInteger := aValue;
end;

function Tosc_ManufacturersDataTableRules.Getmanufacturers_nameValue: String;
begin
  result := DataTable.Fields[idx_osc_Manufacturersmanufacturers_name].AsString;
end;

procedure Tosc_ManufacturersDataTableRules.Setmanufacturers_nameValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Manufacturersmanufacturers_name].AsString := aValue;
end;

function Tosc_ManufacturersDataTableRules.Getmanufacturers_imageValue: String;
begin
  result := DataTable.Fields[idx_osc_Manufacturersmanufacturers_image].AsString;
end;

procedure Tosc_ManufacturersDataTableRules.Setmanufacturers_imageValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Manufacturersmanufacturers_image].AsString := aValue;
end;

function Tosc_ManufacturersDataTableRules.Getdate_addedValue: DateTime;
begin
  result := DataTable.Fields[idx_osc_Manufacturersdate_added].AsDateTime;
end;

procedure Tosc_ManufacturersDataTableRules.Setdate_addedValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_osc_Manufacturersdate_added].AsDateTime := aValue;
end;

function Tosc_ManufacturersDataTableRules.Getlast_modifiedValue: DateTime;
begin
  result := DataTable.Fields[idx_osc_Manufacturerslast_modified].AsDateTime;
end;

procedure Tosc_ManufacturersDataTableRules.Setlast_modifiedValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_osc_Manufacturerslast_modified].AsDateTime := aValue;
end;

function Tosc_ManufacturersDataTableRules.Getrdx_manufacturers_id_localValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Manufacturersrdx_manufacturers_id_local].AsInteger;
end;

procedure Tosc_ManufacturersDataTableRules.Setrdx_manufacturers_id_localValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Manufacturersrdx_manufacturers_id_local].AsInteger := aValue;
end;


{ Tosc_LanguagesDataTableRules }
constructor Tosc_LanguagesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor Tosc_LanguagesDataTableRules.Destroy;
begin
  inherited;
end;

function Tosc_LanguagesDataTableRules.Getlanguages_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Languageslanguages_id].AsInteger;
end;

procedure Tosc_LanguagesDataTableRules.Setlanguages_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Languageslanguages_id].AsInteger := aValue;
end;

function Tosc_LanguagesDataTableRules.GetnameValue: String;
begin
  result := DataTable.Fields[idx_osc_Languagesname].AsString;
end;

procedure Tosc_LanguagesDataTableRules.SetnameValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Languagesname].AsString := aValue;
end;

function Tosc_LanguagesDataTableRules.GetcodeValue: String;
begin
  result := DataTable.Fields[idx_osc_Languagescode].AsString;
end;

procedure Tosc_LanguagesDataTableRules.SetcodeValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Languagescode].AsString := aValue;
end;

function Tosc_LanguagesDataTableRules.GetimageValue: String;
begin
  result := DataTable.Fields[idx_osc_Languagesimage].AsString;
end;

procedure Tosc_LanguagesDataTableRules.SetimageValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Languagesimage].AsString := aValue;
end;

function Tosc_LanguagesDataTableRules.GetdirectoryValue: String;
begin
  result := DataTable.Fields[idx_osc_Languagesdirectory].AsString;
end;

procedure Tosc_LanguagesDataTableRules.SetdirectoryValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Languagesdirectory].AsString := aValue;
end;

function Tosc_LanguagesDataTableRules.Getsort_orderValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Languagessort_order].AsInteger;
end;

procedure Tosc_LanguagesDataTableRules.Setsort_orderValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Languagessort_order].AsInteger := aValue;
end;


{ Tosc_ProductsDataTableRules }
constructor Tosc_ProductsDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor Tosc_ProductsDataTableRules.Destroy;
begin
  inherited;
end;

function Tosc_ProductsDataTableRules.Getproducts_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Productsproducts_id].AsInteger;
end;

procedure Tosc_ProductsDataTableRules.Setproducts_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Productsproducts_id].AsInteger := aValue;
end;

function Tosc_ProductsDataTableRules.Getproducts_nameValue: String;
begin
  result := DataTable.Fields[idx_osc_Productsproducts_name].AsString;
end;

procedure Tosc_ProductsDataTableRules.Setproducts_nameValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Productsproducts_name].AsString := aValue;
end;

function Tosc_ProductsDataTableRules.Getproducts_descriptionValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_osc_Productsproducts_description].AsString;
end;

procedure Tosc_ProductsDataTableRules.Setproducts_descriptionValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_osc_Productsproducts_description].AsString := aValue.Text;
end;

function Tosc_ProductsDataTableRules.Getproducts_modelValue: String;
begin
  result := DataTable.Fields[idx_osc_Productsproducts_model].AsString;
end;

procedure Tosc_ProductsDataTableRules.Setproducts_modelValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Productsproducts_model].AsString := aValue;
end;

function Tosc_ProductsDataTableRules.Getproducts_date_addedValue: DateTime;
begin
  result := DataTable.Fields[idx_osc_Productsproducts_date_added].AsDateTime;
end;

procedure Tosc_ProductsDataTableRules.Setproducts_date_addedValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_osc_Productsproducts_date_added].AsDateTime := aValue;
end;

function Tosc_ProductsDataTableRules.Getproducts_last_modifiedValue: DateTime;
begin
  result := DataTable.Fields[idx_osc_Productsproducts_last_modified].AsDateTime;
end;

procedure Tosc_ProductsDataTableRules.Setproducts_last_modifiedValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_osc_Productsproducts_last_modified].AsDateTime := aValue;
end;

function Tosc_ProductsDataTableRules.Getproducts_statusValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Productsproducts_status].AsInteger;
end;

procedure Tosc_ProductsDataTableRules.Setproducts_statusValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Productsproducts_status].AsInteger := aValue;
end;

function Tosc_ProductsDataTableRules.Getmanufacturers_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Productsmanufacturers_id].AsInteger;
end;

procedure Tosc_ProductsDataTableRules.Setmanufacturers_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Productsmanufacturers_id].AsInteger := aValue;
end;

function Tosc_ProductsDataTableRules.Getrdx_products_id_localValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Productsrdx_products_id_local].AsInteger;
end;

procedure Tosc_ProductsDataTableRules.Setrdx_products_id_localValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Productsrdx_products_id_local].AsInteger := aValue;
end;


{ Tosc_OrdersDataTableRules }
constructor Tosc_OrdersDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor Tosc_OrdersDataTableRules.Destroy;
begin
  inherited;
end;

function Tosc_OrdersDataTableRules.Getorders_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Ordersorders_id].AsInteger;
end;

procedure Tosc_OrdersDataTableRules.Setorders_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Ordersorders_id].AsInteger := aValue;
end;

function Tosc_OrdersDataTableRules.Getrdx_orders_id_localValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Ordersrdx_orders_id_local].AsInteger;
end;

procedure Tosc_OrdersDataTableRules.Setrdx_orders_id_localValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Ordersrdx_orders_id_local].AsInteger := aValue;
end;

function Tosc_OrdersDataTableRules.Getcustomers_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Orderscustomers_id].AsInteger;
end;

procedure Tosc_OrdersDataTableRules.Setcustomers_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Orderscustomers_id].AsInteger := aValue;
end;

function Tosc_OrdersDataTableRules.Getrdx_customers_id_localValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Ordersrdx_customers_id_local].AsInteger;
end;

procedure Tosc_OrdersDataTableRules.Setrdx_customers_id_localValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Ordersrdx_customers_id_local].AsInteger := aValue;
end;

function Tosc_OrdersDataTableRules.Getdelivery_nameValue: String;
begin
  result := DataTable.Fields[idx_osc_Ordersdelivery_name].AsString;
end;

procedure Tosc_OrdersDataTableRules.Setdelivery_nameValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Ordersdelivery_name].AsString := aValue;
end;

function Tosc_OrdersDataTableRules.Getdelivery_companyValue: String;
begin
  result := DataTable.Fields[idx_osc_Ordersdelivery_company].AsString;
end;

procedure Tosc_OrdersDataTableRules.Setdelivery_companyValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Ordersdelivery_company].AsString := aValue;
end;

function Tosc_OrdersDataTableRules.Getdelivery_street_addressValue: String;
begin
  result := DataTable.Fields[idx_osc_Ordersdelivery_street_address].AsString;
end;

procedure Tosc_OrdersDataTableRules.Setdelivery_street_addressValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Ordersdelivery_street_address].AsString := aValue;
end;

function Tosc_OrdersDataTableRules.Getdelivery_suburbValue: String;
begin
  result := DataTable.Fields[idx_osc_Ordersdelivery_suburb].AsString;
end;

procedure Tosc_OrdersDataTableRules.Setdelivery_suburbValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Ordersdelivery_suburb].AsString := aValue;
end;

function Tosc_OrdersDataTableRules.Getdelivery_cityValue: String;
begin
  result := DataTable.Fields[idx_osc_Ordersdelivery_city].AsString;
end;

procedure Tosc_OrdersDataTableRules.Setdelivery_cityValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Ordersdelivery_city].AsString := aValue;
end;

function Tosc_OrdersDataTableRules.Getdelivery_postcodeValue: String;
begin
  result := DataTable.Fields[idx_osc_Ordersdelivery_postcode].AsString;
end;

procedure Tosc_OrdersDataTableRules.Setdelivery_postcodeValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Ordersdelivery_postcode].AsString := aValue;
end;

function Tosc_OrdersDataTableRules.Getdelivery_stateValue: String;
begin
  result := DataTable.Fields[idx_osc_Ordersdelivery_state].AsString;
end;

procedure Tosc_OrdersDataTableRules.Setdelivery_stateValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Ordersdelivery_state].AsString := aValue;
end;

function Tosc_OrdersDataTableRules.Getdelivery_countryValue: String;
begin
  result := DataTable.Fields[idx_osc_Ordersdelivery_country].AsString;
end;

procedure Tosc_OrdersDataTableRules.Setdelivery_countryValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Ordersdelivery_country].AsString := aValue;
end;

function Tosc_OrdersDataTableRules.Getdelivery_telephoneValue: String;
begin
  result := DataTable.Fields[idx_osc_Ordersdelivery_telephone].AsString;
end;

procedure Tosc_OrdersDataTableRules.Setdelivery_telephoneValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Ordersdelivery_telephone].AsString := aValue;
end;

function Tosc_OrdersDataTableRules.Getlast_modifiedValue: DateTime;
begin
  result := DataTable.Fields[idx_osc_Orderslast_modified].AsDateTime;
end;

procedure Tosc_OrdersDataTableRules.Setlast_modifiedValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_osc_Orderslast_modified].AsDateTime := aValue;
end;

function Tosc_OrdersDataTableRules.Getdate_purchasedValue: DateTime;
begin
  result := DataTable.Fields[idx_osc_Ordersdate_purchased].AsDateTime;
end;

procedure Tosc_OrdersDataTableRules.Setdate_purchasedValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_osc_Ordersdate_purchased].AsDateTime := aValue;
end;

function Tosc_OrdersDataTableRules.Getorders_statusValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Ordersorders_status].AsInteger;
end;

procedure Tosc_OrdersDataTableRules.Setorders_statusValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Ordersorders_status].AsInteger := aValue;
end;

function Tosc_OrdersDataTableRules.Getorders_date_finishedValue: DateTime;
begin
  result := DataTable.Fields[idx_osc_Ordersorders_date_finished].AsDateTime;
end;

procedure Tosc_OrdersDataTableRules.Setorders_date_finishedValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_osc_Ordersorders_date_finished].AsDateTime := aValue;
end;

function Tosc_OrdersDataTableRules.GetcommentsValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_osc_Orderscomments].AsString;
end;

procedure Tosc_OrdersDataTableRules.SetcommentsValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_osc_Orderscomments].AsString := aValue.Text;
end;

function Tosc_OrdersDataTableRules.Getrdx_ship_dateValue: DateTime;
begin
  result := DataTable.Fields[idx_osc_Ordersrdx_ship_date].AsDateTime;
end;

procedure Tosc_OrdersDataTableRules.Setrdx_ship_dateValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_osc_Ordersrdx_ship_date].AsDateTime := aValue;
end;

function Tosc_OrdersDataTableRules.Getrdx_referencia_clienteValue: String;
begin
  result := DataTable.Fields[idx_osc_Ordersrdx_referencia_cliente].AsString;
end;

procedure Tosc_OrdersDataTableRules.Setrdx_referencia_clienteValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Ordersrdx_referencia_cliente].AsString := aValue;
end;


{ Tosc_Orders_productsDataTableRules }
constructor Tosc_Orders_productsDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor Tosc_Orders_productsDataTableRules.Destroy;
begin
  inherited;
end;

function Tosc_Orders_productsDataTableRules.Getorders_products_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Orders_productsorders_products_id].AsInteger;
end;

procedure Tosc_Orders_productsDataTableRules.Setorders_products_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Orders_productsorders_products_id].AsInteger := aValue;
end;

function Tosc_Orders_productsDataTableRules.Getorders_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Orders_productsorders_id].AsInteger;
end;

procedure Tosc_Orders_productsDataTableRules.Setorders_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Orders_productsorders_id].AsInteger := aValue;
end;

function Tosc_Orders_productsDataTableRules.Getproducts_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Orders_productsproducts_id].AsInteger;
end;

procedure Tosc_Orders_productsDataTableRules.Setproducts_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Orders_productsproducts_id].AsInteger := aValue;
end;

function Tosc_Orders_productsDataTableRules.Getrdx_products_id_localValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Orders_productsrdx_products_id_local].AsInteger;
end;

procedure Tosc_Orders_productsDataTableRules.Setrdx_products_id_localValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Orders_productsrdx_products_id_local].AsInteger := aValue;
end;

function Tosc_Orders_productsDataTableRules.Getproducts_modelValue: String;
begin
  result := DataTable.Fields[idx_osc_Orders_productsproducts_model].AsString;
end;

procedure Tosc_Orders_productsDataTableRules.Setproducts_modelValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Orders_productsproducts_model].AsString := aValue;
end;

function Tosc_Orders_productsDataTableRules.Getproducts_nameValue: String;
begin
  result := DataTable.Fields[idx_osc_Orders_productsproducts_name].AsString;
end;

procedure Tosc_Orders_productsDataTableRules.Setproducts_nameValue(const aValue: String);
begin
  DataTable.Fields[idx_osc_Orders_productsproducts_name].AsString := aValue;
end;

function Tosc_Orders_productsDataTableRules.Getproducts_priceValue: Float;
begin
  result := DataTable.Fields[idx_osc_Orders_productsproducts_price].AsFloat;
end;

procedure Tosc_Orders_productsDataTableRules.Setproducts_priceValue(const aValue: Float);
begin
  DataTable.Fields[idx_osc_Orders_productsproducts_price].AsFloat := aValue;
end;

function Tosc_Orders_productsDataTableRules.Getfinal_priceValue: Float;
begin
  result := DataTable.Fields[idx_osc_Orders_productsfinal_price].AsFloat;
end;

procedure Tosc_Orders_productsDataTableRules.Setfinal_priceValue(const aValue: Float);
begin
  DataTable.Fields[idx_osc_Orders_productsfinal_price].AsFloat := aValue;
end;

function Tosc_Orders_productsDataTableRules.Getproducts_taxValue: Float;
begin
  result := DataTable.Fields[idx_osc_Orders_productsproducts_tax].AsFloat;
end;

procedure Tosc_Orders_productsDataTableRules.Setproducts_taxValue(const aValue: Float);
begin
  DataTable.Fields[idx_osc_Orders_productsproducts_tax].AsFloat := aValue;
end;

function Tosc_Orders_productsDataTableRules.Getproducts_quantityValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Orders_productsproducts_quantity].AsInteger;
end;

procedure Tosc_Orders_productsDataTableRules.Setproducts_quantityValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Orders_productsproducts_quantity].AsInteger := aValue;
end;


{ Tosc_Orders_status_historyDataTableRules }
constructor Tosc_Orders_status_historyDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor Tosc_Orders_status_historyDataTableRules.Destroy;
begin
  inherited;
end;

function Tosc_Orders_status_historyDataTableRules.Getorders_status_history_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Orders_status_historyorders_status_history_id].AsInteger;
end;

procedure Tosc_Orders_status_historyDataTableRules.Setorders_status_history_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Orders_status_historyorders_status_history_id].AsInteger := aValue;
end;

function Tosc_Orders_status_historyDataTableRules.Getorders_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Orders_status_historyorders_id].AsInteger;
end;

procedure Tosc_Orders_status_historyDataTableRules.Setorders_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Orders_status_historyorders_id].AsInteger := aValue;
end;

function Tosc_Orders_status_historyDataTableRules.Getrdx_orders_id_localValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Orders_status_historyrdx_orders_id_local].AsInteger;
end;

procedure Tosc_Orders_status_historyDataTableRules.Setrdx_orders_id_localValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Orders_status_historyrdx_orders_id_local].AsInteger := aValue;
end;

function Tosc_Orders_status_historyDataTableRules.Getorders_status_idValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Orders_status_historyorders_status_id].AsInteger;
end;

procedure Tosc_Orders_status_historyDataTableRules.Setorders_status_idValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Orders_status_historyorders_status_id].AsInteger := aValue;
end;

function Tosc_Orders_status_historyDataTableRules.Getdate_addedValue: DateTime;
begin
  result := DataTable.Fields[idx_osc_Orders_status_historydate_added].AsDateTime;
end;

procedure Tosc_Orders_status_historyDataTableRules.Setdate_addedValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_osc_Orders_status_historydate_added].AsDateTime := aValue;
end;

function Tosc_Orders_status_historyDataTableRules.Getcustomer_notifiedValue: Integer;
begin
  result := DataTable.Fields[idx_osc_Orders_status_historycustomer_notified].AsInteger;
end;

procedure Tosc_Orders_status_historyDataTableRules.Setcustomer_notifiedValue(const aValue: Integer);
begin
  DataTable.Fields[idx_osc_Orders_status_historycustomer_notified].AsInteger := aValue;
end;

function Tosc_Orders_status_historyDataTableRules.GetcommentsValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_osc_Orders_status_historycomments].AsString;
end;

procedure Tosc_Orders_status_historyDataTableRules.SetcommentsValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_osc_Orders_status_historycomments].AsString := aValue.Text;
end;


initialization
  RegisterDataTableRules(RID_osc_Customers, Tosc_CustomersDataTableRules);
  RegisterDataTableRules(RID_GetLastID, TGetLastIDDataTableRules);
  RegisterDataTableRules(RID_osc_AddressBook, Tosc_AddressBookDataTableRules);
  RegisterDataTableRules(RID_TiendaWeb, TTiendaWebDataTableRules);
  RegisterDataTableRules(RID_osc_Manufacturers, Tosc_ManufacturersDataTableRules);
  RegisterDataTableRules(RID_osc_Languages, Tosc_LanguagesDataTableRules);
  RegisterDataTableRules(RID_osc_Products, Tosc_ProductsDataTableRules);
  RegisterDataTableRules(RID_osc_Orders, Tosc_OrdersDataTableRules);
  RegisterDataTableRules(RID_osc_Orders_products, Tosc_Orders_productsDataTableRules);
  RegisterDataTableRules(RID_osc_Orders_status_history, Tosc_Orders_status_historyDataTableRules);

end.
